/*

        Millennium Screen Saver for Windows

					Definitions

*/

#define ScreenSaver

#include <windows.h>
#include <winbase.h>
#include <scrnsave.h>
#include <string.h>
#include <time.h>

#ifndef RC_INVOKED
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <sys/types.h>
#include <sys/timeb.h>
#endif

typedef RGBQUAD *LPRGBQUAD;

#include "resource.h"

//      String codes in resource file

#define IDS_APPNAME				103				// Application name/title

#define IDS_FORMATS            200          	// Format base
#define Format(n)   rstring(IDS_FORMATS + (n))

//      Resource ID numbers

//	Definitions for screen saver unique objects

#define ID_STARTUP					102
#define ID_HELP                     110

#define PI 3.14159265358979323846  /* Assume not near black hole nor in
                                      Tennessee */

#define V       (void)

#define EOS     '\0'

//	Frequently used astronomical constants

#define J2000				2465442.5		// Julian day of Y2038 bug epoch
#define C2000				(J2000 - 0.5)	// Civil Y2038 bug

/*  Handy mathematical functions  */

#ifdef abs
#undef abs
#endif

#define sgn(x) (((x) < 0) ? -1 : ((x) > 0 ? 1 : 0))       /* Extract sign */
#define abs(x) ((x) < 0 ? (-(x)) : (x))                   /* Absolute val */

#define RepositionTime	10		// Reposition image every RepositionTime minutes

//  Determine number of elements in an array

#define ELEMENTS(array) (sizeof(array)/sizeof((array)[0]))

//  Assertion checking for Windows

#ifndef NDEBUG
#define assert(x) { if (!(x)) { char erm[128]; wsprintf((LPSTR) erm, \
        (LPSTR) "Assertion %s failed at line %d of file %s.", (LPCSTR) #x, __LINE__,(LPSTR) __FILE__); \
        FatalAppExit(0, (LPCSTR) erm); }}
#else
#define assert(x)
#endif

//	Make sure no debug output remains in production builds: use Honk(x) for debug MessageBeep(x)

#ifdef NDEBUG
#ifdef OutputDebugString
#undef OutputDebugString
#endif
#define OutputDebugString(x) DebugOutputInProductionBuild()
#define Honk(x) DebugOutputInProductionBuild()
#else
#define Honk(x)	MessageBeep(x)
#endif

extern char szString[128];		// Variable to load resource strings
#define hInst	 hMainInstance  // Redefinitions for screen saver lib compatibility
#define hWndMain hMainWindow
extern HINSTANCE hInst;			// Class instance pointer
extern HWND hWndMain;			// Main window pointer
extern double faketime;         // Time for simulation / testing
extern int ImageWid, ImageHgt;	// Image width and height
extern int imageSize;			// Image size
extern int hourChime;			// Chime on hour
extern int halfHourChime;		// Chime on half-hour
extern int playTheme;			// Play theme at start ?
extern int startChime;			// Chime at start (if not playing theme) ?
extern int exitChime;			// Chime at exit ?
extern int showSnake;			// Show the snake image ?
extern int showDateTime;		// Show date and time ?
extern int millenniumStarts;	// Date - 2000 when millennium begins
extern int targetDate;			// Julian day we're counting down to
extern int countToday;			// Count current interval in those remaining
extern int testMode;			// Test mode ?
extern int themeFileIndex;		// Theme file name index in string table

#define WindowProc(x) LRESULT CALLBACK x(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)

/* Dialogue service functions. */

#define DialogueProc(name) INT_PTR CALLBACK name(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)

//  From JULIAN.C

extern double jtime(struct tm *t);
extern void jyear(double td, long *yy, int *mm, int *dd),
            jhms(double j, int *h, int *m, int *s);
extern double ucttoj(long year, int mon, int mday,
                     int hour, int min, int sec);
extern int jwday(double j);

//	From SCRNWIND.C

#ifdef TRACY
extern void Blooie(char *s);
#endif
extern void play_sound(int which);
extern void set_tm_time(struct tm *t, BOOL islocal);
extern void findThemeFile(void);

//	From SUNCALC.C

extern void ssavetime(HDC hDC, struct tm lt, RECT tr, COLORREF tcol);
extern void localtimeformat(void);
extern char *rstring(int resid);

//	From SCRNSAVE.C

extern void GetIniEntries(void);
extern void GetIniSettings(void);

//	From VIEWFROM.C

extern void needImageBitmap(void);
extern void release_image(void);
extern void updviewfrom(HWND hWnd, int isize, int offX, int offY, BOOL repositioned);
