/*

			Millennium Screen Saver

*/

#include "milscrsv.h"

/* Global used by SCRNSAVE.LIB. Required for all screen savers. */

char szAppName[40];

/* Globals exported. */

char szName[] = "Millennium Screen Saver";

/* Externals defined in SCRNSAVE.LIB. Required for all screen savers. */

HINSTANCE hMainInstance;
HWND hMainWindow;
char szName[TITLEBARNAMELEN];
char szScreenSaver[22];
char szHelpFile[MAXFILELEN];
char szNoHelpMemory[BUFFLEN];
UINT MyHelpMessage;
HOOKPROC fpMessageFilter;

/* RegisterDialogClasses -- Entry point for registering window
							classes required by configuration dialog box. */

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
    return TRUE;
}

/* ScreenSaverConfigureDialog -- Dialogue box function for
								 screen saver configuration dialogue. */

DialogueProc(ScreenSaverConfigureDialog)
{
	static HWND hIDOK;
	BOOL intok;
	int is;
	long t_year;
	int t_month, t_day;

    switch (message) {
        case WM_INITDIALOG:
            GetIniEntries();
            GetIniSettings();

			for (is = 0; is < 12; is++) {
				SendDlgItemMessage(hDlg, IDC_CO_MOIS, CB_ADDSTRING, 0, (LPARAM) rstring(IDS_MOIS + is));
			}
			jyear(targetDate + 0.5, &t_year, &t_month, &t_day);
			SendDlgItemMessage(hDlg, IDC_CO_MOIS, CB_SETCURSEL, t_month - 1, 0);
			SetDlgItemInt(hDlg, IDC_CO_JOUR, t_day, FALSE);
			SetDlgItemInt(hDlg, IDC_CO_AN, t_year, FALSE);

			findThemeFile();
			if (themeFileIndex == 0) {
				EnableWindow(GetDlgItem(hDlg, IDC_CO_PLAYTHEME), FALSE);
			}
			CheckDlgButton(hDlg, IDC_CO_PLAYTHEME, playTheme);
			CheckDlgButton(hDlg, IDC_CO_CHIME_START, startChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_HOUR, hourChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_HALF, halfHourChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_EXIT, exitChime); 
			CheckDlgButton(hDlg, IDC_CO_DATE_TIME, showDateTime); 
			CheckDlgButton(hDlg, IDC_CO_COUNT_TODAY, countToday); 
			CheckDlgButton(hDlg, IDC_CO_TESTMODE, testMode);

			if (imageSize == 0) {
				SetDlgItemText(hDlg, IDC_IMAGE_SIZE, rstring(IDS_AUTO));
			} else {
				SetDlgItemInt(hDlg, IDC_IMAGE_SIZE, imageSize, FALSE);
			}

            hIDOK = GetDlgItem(hDlg, IDOK);
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
					playTheme = IsDlgButtonChecked(hDlg, IDC_CO_PLAYTHEME);
					startChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_START);
					hourChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_HOUR);
					halfHourChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_HALF);
					exitChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_EXIT);
					showDateTime = IsDlgButtonChecked(hDlg, IDC_CO_DATE_TIME);
					countToday = IsDlgButtonChecked(hDlg, IDC_CO_COUNT_TODAY);
					testMode = IsDlgButtonChecked(hDlg, IDC_CO_TESTMODE);

					t_month = SendDlgItemMessage(hDlg, IDC_CO_MOIS, CB_GETCURSEL, 0, 0);
					if (t_month == CB_ERR) {
						targetDate = (int) C2000;
					} else {
						t_day = GetDlgItemInt(hDlg, IDC_CO_JOUR, &intok, FALSE);
						t_year = GetDlgItemInt(hDlg, IDC_CO_AN, &intok, FALSE);
						targetDate = (int) (ucttoj(t_year, t_month, t_day, 0, 0, 0) - 0.5);
					}

					is = GetDlgItemInt(hDlg, IDC_IMAGE_SIZE, &intok, FALSE);
					if (intok) {
						imageSize = is;
					} else {
						imageSize = 0;
					}
					
					/* Save all configuration parameters in the registry. */

                    {
						HKEY keyh;
						DWORD dispos;
						TCHAR keyname[80];
						
						strcpy(keyname, "Software\\Fourmilab.ch\\");
						strcat(keyname, szAppName);
						if (RegCreateKeyEx(HKEY_CURRENT_USER,
									keyname,					// Subkey name
									0,							// Reserved
									"",							// Bogus class string
									REG_OPTION_NON_VOLATILE,	// Options
									KEY_ALL_ACCESS,				// Access rights			
									NULL,						// Security attributes
									&keyh,						// Returned handle to the key
									&dispos) == ERROR_SUCCESS) { // Returned disposition
#define regStore(name, value) RegSetValueEx(keyh, rstring(name), 0, REG_DWORD, (BYTE *) &value, sizeof(value))
								regStore(INI_PLAYTHEME, playTheme);  
								regStore(INI_STARTCHIME, startChime);  
								regStore(INI_HOURCHIME, hourChime);			                
								regStore(INI_HALFHOURCHIME, halfHourChime);  
								regStore(INI_EXITCHIME, exitChime);  
								regStore(INI_DATE_TIME, showDateTime);						
								regStore(INI_TESTMODE, testMode);
								regStore(INI_WHICHYEAR, millenniumStarts);
								regStore(INI_TARGETDATE, targetDate);
								regStore(INI_COUNT_TODAY, countToday);								
								regStore(INI_IMAGESIZE, imageSize);								

								RegCloseKey(keyh);
						}
                   }
#undef regStore              
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    return TRUE;

                case ID_HELP:
DoHelp:
                    MessageBox(hDlg, "Millennium screen saver.", szName, MB_OK);
                    break;
            }
            break;

        default:
            if (message == MyHelpMessage)     // Context sensitive help msg.
                goto DoHelp;
    }
    return FALSE;
}

/* GetIniSettings -- Get initial settings from the registry.  */

void GetIniSettings(void)
{
	HKEY keyh;
	TCHAR keyname[80];	

	strcpy(keyname, "Software\\Fourmilab.ch\\");
	strcat(keyname, szAppName);

	if (RegOpenKeyEx(HKEY_CURRENT_USER,
			keyname,				// Subkey name
			0,						// Reserved
			KEY_QUERY_VALUE,		// Security access mask
			&keyh) == ERROR_SUCCESS) {
		DWORD vsize;
		DWORD vtype =  REG_DWORD;

#define regGet(name, value) vsize = sizeof(value); RegQueryValueEx(keyh, rstring(name), NULL, &vtype, (BYTE *) &value, &vsize)
		regGet(INI_PLAYTHEME, playTheme);
		regGet(INI_STARTCHIME, startChime);
		regGet(INI_HOURCHIME, hourChime);	
		regGet(INI_HALFHOURCHIME, halfHourChime);
		regGet(INI_EXITCHIME, exitChime);
		regGet(INI_DATE_TIME, showDateTime);
		regGet(INI_TESTMODE, testMode);		
		regGet(INI_WHICHYEAR, millenniumStarts);
		regGet(INI_TARGETDATE, targetDate);
		regGet(INI_COUNT_TODAY, countToday);
		regGet(INI_IMAGESIZE, imageSize);
		
		RegCloseKey(keyh);
#undef regGet
	} else {
    	playTheme = TRUE; 
    	startChime = TRUE; 
    	hourChime = TRUE; 
    	halfHourChime = TRUE;
		exitChime = TRUE;
		showDateTime = TRUE;
		testMode = FALSE;
		targetDate = (int) C2000;
		countToday = TRUE;
		imageSize = 0;
	}

}

void GetIniEntries(void)
{
	// Load common strings from string table
    LoadString(hMainInstance, idsAppName, szAppName, 40); 
	LoadString(hMainInstance, idsScreenSaver, szScreenSaver, 22);
	LoadString(hMainInstance, idsHelpFile, szHelpFile, MAXFILELEN);
	LoadString(hMainInstance, idsNoHelpMemory, szNoHelpMemory, BUFFLEN);
}
